<?php

if (isset($_REQUEST["delay"]) && is_numeric($_REQUEST["delay"]))
    sleep($_REQUEST["delay"]);

/* File to write to */
$theFile = "ratings.txt";
$totalsFile = "totals.txt";

/* pull the user ratings via the query string */
$rating = htmlentities(substr(urldecode(gpc("rating")),0,1024));
$comment = htmlentities(substr(urldecode(gpc("comment")),0,1024));
$response = htmlentities(substr(urldecode(gpc("response")),0,1024));
$error = htmlentities(substr(urldecode(gpc("error")),0,1024));
$callback = htmlentities(substr(urldecode(gpc("callback")),0,1024));

if ($rating == "")
    $rating = 0;

$transport = "XHR";

if ($response == "")
    $response = "text";

/* if error is set, set appropriate header and then return */
if ($error != "")
{
    if ($error == "404")
	header("HTTP/1.1 404 Not Found\n\n");
    else
	header("HTTP/1.1 500 Internal Server Error\n\n");

    exit;
}


/* record the IP address and time */
$userIP =  $_SERVER['REMOTE_ADDR'];;
$currentTime = date("M d y h:i:s A");

/* open the file and get the contents */
$filehandle = fopen($theFile, "r");
if ($filehandle)
{
    $data = fread($filehandle, filesize($theFile));
    fclose($filehandle);
}
else
   die('Failed to read file');


/* open the file and write line to the top of the file */    
$filehandle = fopen($theFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$rating\t $transport\t $userIP @ $currentTime\t $comment\n");
    fwrite($filehandle, $data);
    fclose($filehandle);
}
else
    die('Failed to write file');

//get the totals
$votes = $total = $average = 0;
$filehandle = fopen($totalsFile, "r+");
if ($filehandle) 
{
    $line = fgets($filehandle, 4096);
    $tokens = explode("\t", $line);

    if (count($tokens) > 1)
    {
        $votes = $tokens[0] + 1;
        $total = $tokens[1] + $rating;
    }

    fclose($filehandle);
}
else
    die('Failed to read file');

$filehandle = fopen($totalsFile, "w+");
if ($filehandle) 
{
    fwrite($filehandle,"$votes\t$total\n");
    fclose($filehandle);
}
else
    die('Failed to write file');

if ($votes != 0) $average = round(($total/$votes), 2);

// send the right headers
$message = "";
if ($response == "text")
{
    $message = "Thank you for voting.  You rated this a <strong>$rating</strong>.  There are <strong>$votes</strong> total votes.  The average is <strong>$average</strong>.  You can see the ratings in the <a href='http://ajaxref.com/ch3/ratings.txt' target='_blank'>ratings file</a>";
}
else if ($response == "xml")
{
    header("Content-Type: text/xml");

    $message = 
	"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n
		<pollresults>\r\n

		<rating>$rating</rating>\r\n
		<average>$average</average>\r\n
		<votes>$votes</votes>\r\n

		</pollresults>\r\n
	" ;

}
else if ($response == "JSON")
{
    require_once('JSON.php');
    $json = new Services_JSON();
    $jsonResponse = new ResponseData();
    $jsonResponse->rating = $rating;
    $jsonResponse->votes = $votes;
    $jsonResponse->average = $average;

    $message = $json->encode($jsonResponse);
}

echo $message;

/* Helper functions */
function gpc($name)
{
    if (isset($_GET[$name]))
	return $_GET[$name];
    else if (isset($_POST[$name]))
	return $_POST[$name];
    else if (isset($_COOKIE[$name]))
	return $_COOKIE[$name];
    else
	return "";
}


class ResponseData
{
    public $average = 0;
    public $rating = 0;
    public $votes = 0;
    public $total = 0;
}

?>
